<template>
  <div class="distributions">
    <div class="container" id="overview-intro" >
      <div class="row">
        <div class="col-sm mb-5">
          <div class="row catalogue_intro-section-text">
            <h1 class="col-12">{{ $t("message.catalogue_detail.distributions.title") }}</h1>
            <p class="col-8">{{ $t("message.catalogue_detail.distributions.introduction") }} </p>
            <div class="col pag">
              <ul class="pagination pagination-sm float-right">
                <li class="page-item"
                    v-for="(n, index) in totalpages"
                    v-if="Math.abs(n - currentPage)  < 2 || n === totalpages || n === 1"
                    :key="n"
                    :class="{ 'active': index === currentPage-1, 'last': n === totalpages && Math.abs(n - currentPage)  > 3, 'first': n === 1 && Math.abs(n - currentPage) > 3 }">
                  <a href="" @click.prevent="fetchCatalogueDistributions(n)" class="page-link" >{{n}}</a>
                </li>
              </ul>
            </div>
          </div>
          <div v-if="this.loading === true" class="spinner-space">
            <div class="lds-ring" id="spinner-distributions">
              <div></div>
              <div></div>
              <div></div>
              <div></div>
            </div>
          </div>
          <div v-else v-for="(distribution, index) in getCatalogueDistributions" class="distribution-detail" :key="index">
            <div class="distribution-headline">
              <app-link :to="distribution.reference">
                <h3>{{distribution.title}}</h3>
              </app-link>
              <!-- <small>{{ distribution.accessUrlTimeStamp }}</small> -->
            </div>
            <hr>
            <!-- AccessURLs -->
            <div class="distribution-subheadline">
              <h6>{{ $t("message.catalogue_detail.distributions.access_url") }}</h6>
            </div>
            <div class="distribution-info">
              <a class="d-block" :href="distribution.accessUrl" target="_blank">
                <small>{{distribution.accessUrl}}</small>
              </a>
              <small>{{ distribution.accessUrlTimeStamp | parseDate }}</small>
            </div>
            <span v-if="distribution.accessUrlStatusCode === 0" class="distribution-no-dl-url">
                {{ $t("message.catalogue_detail.distributions.not_available_access") }}
              </span>
            <div v-else class="distribution-subheadline2">
              {{ $t("message.common.status") }}:
              <span class="distribution-status-code">{{ distribution.accessUrlStatusCode }}</span>
            </div>
            <!-- <div class="distribution-subheadline2">
              {{ $t("message.catalogue_detail.distributions.format.name") }}:
              <span class="distribution-info">{{ distribution.format }}</span>
            </div> -->
            <br>
            <!-- DownloadURLs -->
            <div class="distribution-subheadline">
              <h6>{{ $t("message.catalogue_detail.distributions.download_url") }}</h6>
            </div>
            <div class="distribution-info">
              <div v-if="!distribution.downloadUrl">
                <span class="distribution-no-dl-url">{{ $t("message.catalogue_detail.distributions.not_available_dl") }}</span>
                <br>
              </div>
              <div v-else>
                <a class="d-block" :href="distribution.downloadUrl" target="_blank">
                  <small>{{ distribution.downloadUrl }}</small>
                </a>
                <small>{{ distribution.downloadUrlTimeStamp | parseDate }}</small>
                <br>
                <span class="distribution-subheadline2">{{ $t("message.common.status") }}: </span>
                <span class="distribution-status-code">{{ distribution.downloadUrlStatusCode }}</span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
/* eslint-disable */
import {mapActions, mapGetters} from 'vuex'
import AppLink from '@/components/AppLink'

export default {
  name: 'CatalogueDetailDistributions',
  components: { AppLink },
  metaInfo () {
    return {
      title: `${this.$t('message.common.site_title_distributions')} - ${this.title} - ${this.$t('message.common.site_title')}`
    }
  },
  data () {
    return {
      currentPage: 1,
      loading: true
    }
  },
  props: {
    id: {
      type: String,
      required: true
    },
    title: {
      type: String,
    },
  },
  filters: {
    parseDate(utcTimeString) {
      const date = new Date(utcTimeString)
      return `${date.toLocaleDateString()} ${date.toLocaleTimeString()}`
    }
  },
  mounted () {},
  computed: {
    // import store-getters
    ...mapGetters([
      'getCatalogueDistributions',
      'getCatalogueDistributionsSize'
    ]),
    totalpages () {
      if (this.getCatalogueDistributionsSize > 20) {
        return Math.ceil(this.getCatalogueDistributionsSize / 10)
      }
    }
  },
  methods: {
    // import store-actions
    ...mapActions([
      'loadCatalogueDistributions'
    ]),
    fetchCatalogueDistributions (n) {
      this.currentPage = n;
      this.loading = true;
      this.loadCatalogueDistributions({ id: this.id, currentPage: this.currentPage })
        .then(() => {
          this.loading = false;
        });
    }
  },
  created() {
    if (this.id) {
      this.loadCatalogueDistributions({ id: this.id, currentPage: this.currentPage })
        .then(() => {
          this.loading = false;
        });
    }
  }
}
</script>

<style scoped>
h1 {
  font-size: 1.75rem;
}
</style>
